/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/

/* Variables ----------------------------------------------------------------*/
/******************************************************************************
* Function Name  : HALL_StateStop
* Description    : HALLжϾֹ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void HALL_StateStop(void)                          //ֹͣж
{
    if(HALL_Cal_M.DetectUpwindFlag==1)//ʱ ɲ ¹ܴ4adcʱɼ綯
    {
        HALL_Cal_M.Brake_Judg_stop_Flag=1;
        if(HALL_Cal_M.Flystar_Timer_Overflow_Cnt>=HALL_Cal_M.Flystart_Timer_Overflow_Thre)
        {
            TIM1->CCER |=((1<<0)|(1<<4)|(1<<8));//ʹϹ
            PID_Output_Init(&SpeedRegStruc_M,&dCurrRegStruc_M,&qCurrRegStruc_M); //PIDʼ
            SVPWM_Status_Initial_M(&SVPWM_Cal_M,TIM1);//SVPWM״̬ʼ
            ADC_Start(ENABLE,ADC1);//ADCתʹ
            RunningStatus_M = RUN;
        }
    }
}
/******************************************************************************
* Function Name  : HALL_StateDirCheck
* Description    : HALL˳紦
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void HALL_StateDirCheck(void)
{
    if(HALL_Cal_M.Angspeed_Aver1<UPWIND_ANGSPEED)
    {
        HALL_Cal_M.DetectUpwindFlag=1;
        TIM1->CCER &=~((1<<0)|(1<<4)|(1<<8));
        TIM1->CH1CVR =  1;
        TIM1->CH2CVR =  1;
        TIM1->CH3CVR =  1;
        TIM_CtrlPWMOutputs(TIM1,ENABLE);
        Time_Delay_Set_500us(STOP_DELAY_TIME,&BreakwaitCnt);
        RunningStatus_M = BRAKE;
    }
    else if(HALL_Cal_M.Angspeed_Aver1>=UPWIND_ANGSPEED&&HALL_Cal_M.Angspeed_Aver1<=TAILWIND_ANGSPEED)
    {
        HALL_Cal_M.DetectUpwindFlag=2;
        RunningStatus_M = RUN;
        ADC_Start(ENABLE,ADC1);
    }

    else if(HALL_Cal_M.Angspeed_Aver1>TAILWIND_ANGSPEED)
    {
        HALL_Cal_M.DetectUpwindFlag=3;
        SpeedRamp_M.Aftramp = HALL_Cal_M.Angspeed_Aver1;
        RunningStatus_M = RUN;
        ADC_Start(ENABLE,ADC1);
    }
       TIM_CtrlPWMOutputs(TIM1,ENABLE);
}

/******************************************************************************
* Function Name  : Motor_Start_Init
* Description    : ǰĳʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Motor_Start_Init_M(void)
{
    Speed_Initial();

    PID_Output_Init(&SpeedRegStruc_M,&dCurrRegStruc_M,&qCurrRegStruc_M); //PIDʼ

    Motor_Status_Initial_M(); //״̬ͼʼ

    //Dʼ
    Dcurr_Process_Init(&DCurrProcess_M,DAXIS_CURR_REF_INIT_M,\
                        DAXIS_CURR_WEAK_SPEED_M,DAXIS_CURR_REF_STEP_M);

    SVPWM_Status_Initial_M(&SVPWM_Cal_M,TIM1);//SVPWM״̬ʼ

    ADC_Status_Init (&ADC_M,ADC1,TIM1);       //ADC״̬ʼ

    Buffer_Clear(&(HALL_SpeedBuffer_M[0]),&HALL_SpeedBuffPara_M);//HALL۲תʼ

    HALL_Status_Init_M(&HALL_Cal_M,&HALL_Status_M);//HALL״̬ʼ

    ADC_Offset_Reading(ADC1,&ADC_M); //ƫöȡ

    SVPWM_Calculation(&SVPWM_Cal_M,&StatVoltRef2S_M,TIM1);//Ծٵݳ

    TIM_CtrlPWMOutputs(TIM1,ENABLE); //ʹܶʱPWM

    Time_Wait_500us(1);  //ӳ0.5ms

    SVPWM_Status_Initial_M(&SVPWM_Cal_M,TIM1);//SVPWM״̬ʼ

#ifdef FLY_STARTUP
   TIM_CtrlPWMOutputs(TIM1,DISABLE); //ʹܶʱPWM
#else
    ADC_Start(ENABLE,ADC1);//ADCתʹ
#endif
    TIM_Cmd(TIM4, ENABLE);
}
